JobSub - Bug #9535

Jobsub server not compatible with proxy generated using certs issued by ClLogon OSG CA
07/10/2015 04:25 PM - Neha Sharma

Status: Closed Start date: 07/10/2015
Priority: Normal Due date:

Assignee: Dennis Box % Done: 0%
Category: Estimated time: 0.00 hour
Target version: vi.1.5 Spent time: 0.00 hour
First Occurred: Stakeholders:

Occurs In:

Description

| use fermicloud042 (Dennis's test node) to test job submission.

Proxy | have is:

[neha@fermicloud042 ~]$ voms-proxy-info -all -file /home/neha/x509up_u60158

subject :/DC=org/DC=opensciencegrid/O=0Open Science Grid/OU=People/CN=Neha Sharma 225/CN=proxy
issuer :/DC=org/DC=opensciencegrid/O=0Open Science Grid/OU=People/CN=Neha Sharma 225
identity : /DC=org/DC=0opensciencegrid/O=0pen Science Grid/OU=People/CN=Neha Sharma 225
type : proxy

strength : 1024 bits

path  :/home/neha/x509up_u60158

timeleft : 10:12:29

key usage : Digital Signature, Key Encipherment, Data Encipherment === VO fermilab extension information ===
VO : fermilab

subject :/DC=org/DC=0opensciencegrid/O=0pen Science Grid/OU=People/CN=Neha Sharma 225
issuer :/DC=com/DC=DigiCert-Grid/O=0Open Science Grid/OU=Services/CN=cloudvoms1.fnal.gov
attribute : /fermilab/Role=NULL/Capability=NULL

attribute : /fermilab/accelerator/Role=NULL/Capability=NULL

attribute : /fermilab/annie/Role=NULL/Capability=NULL

attribute : /fermilab/argoneut/Role=NULL/Capability=NULL

attribute : /fermilab/auger/Role=NULL/Capability=NULL

attribute : /fermilab/cdf/Role=NULL/Capability=NULL

attribute : /fermilab/cdms/Role=NULL/Capability=NULL

attribute : /fermilab/chips/Role=NULL/Capability=NULL

attribute : /fermilab/coupp/Role=NULL/Capability=NULL

attribute : /fermilab/darkside/Role=NULL/Capability=NULL

attribute : /fermilab/genie/Role=NULL/Capability=NULL

attribute : /fermilab/gm2/Role=NULL/Capability=NULL

attribute : /fermilab/grid/Role=NULL/Capability=NULL

attribute : /fermilab/lar1/Role=NULL/Capability=NULL

attribute : /fermilab/lar1nd/Role=NULL/Capability=NULL

attribute : /fermilab/lariat/Role=NULL/Capability=NULL

attribute : /fermilab/mars/Role=NULL/Capability=NULL

attribute : /fermilab/mars/accel/Role=NULL/Capability=NULL

attribute : /fermilab/mars/gm2/Role=NULL/Capability=NULL

attribute : /fermilab/mars/Ibne/Role=NULL/Capability=NULL

attribute : /fermilab/mars/mu2e/Role=NULL/Capability=NULL

attribute : /fermilab/minerva/Role=NULL/Capability=NULL

attribute : /fermilab/miniboone/Role=NULL/Capability=NULL

attribute : /fermilab/minos/Role=NULL/Capability=NULL

attribute : /fermilab/minos/ukminos/Role=NULL/Capability=NULL

attribute : /fermilab/minos/usminos/Role=NULL/Capability=NULL

attribute : /fermilab/mipp/Role=NULL/Capability=NULL

attribute : /fermilab/mu2e/Role=NULL/Capability=NULL

attribute : /fermilab/nova/Role=NULL/Capability=NULL

attribute : /fermilab/numix/Role=NULL/Capability=NULL

attribute : /fermilab/patriot/Role=NULL/Capability=NULL

attribute : /fermilab/seaquest/Role=NULL/Capability=NULL

attribute : /fermilab/theory/Role=NULL/Capability=NULL

attribute : /fermilab/uboone/Role=NULL/Capability=NULL
timeleft : 10:12:29
uri : cloudvomsi1.fnal.gov:15001
[neha@fermicloud042 ~]$

| set the env variable

[neha@fermicloud042 ~]$ export X509_USER_PROXY=/home/neha/x509up_u60158
[neha@fermicloud042 ~]$

[neha@fermicloud042 ~]$ echo $X509_USER_PROXY

/home/neha/x509up_u60158

[neha@fermicloud042 ~]$

and submit job

[neha@fermicloud042 ~]$ jobsub_submit -G fermilab --jobsub-server=fifebatch-dev.fnal.gov
--resource-provides=usage_model=DEDICATED,OPPORTUNISTIC file:///home/neha/hello_world.sh
File "/fnal/ups/prd/jobsub_client/v1_1_3_cli/NULL/jobsub_submit", line 267, in <module>
sys.exit(main(sys.argv))

File "/fnal/ups/prd/jobsub_client/v1_1_3_cli/NULL/jobsub_submit", line 254, in main
http_code = js_client.submit()

File "/fnal/ups/prd/jobsub_client/v1_1_3_cli/NULL/jobsubClient.py", line 327, in submit
self.bestSchedd()

File "/fnal/ups/prd/jobsub_client/v1_1_3_cli/NULL/jobsubClient.py", line 546, in bestSchedd
traceback.print_stack()

HTTP response:0 PyCurl Error 56: SSL read: errno -12195

[neha@fermicloud042 ~]$

which as you can see, fails.

| suspected this could be due ClLogon OSG CA cert package not installed on submit and jobsub server node (
fermicloud114.fnal.gov ). So, | went ahead and did that and restarted httpd

[neha@fermicloud042 ~]$ rpm -ga | grep cilogon
cilogon-osg-ca-cert-1.0-1.0sg32.el6.noarch
[neha@fermicloud042 ~]$

[root@fermicloud114 ~]# rpm -ga | grep cilogon
cilogon-osg-ca-cert-1.0-1.0sg32.el6.noarch
[root@fermicloud114 ~J#

Job submission still fails with same error.

There is nothing in server logs related to this failed request.

Please get ClLogon user cert (I will send instructions) and investigate this issue.

History

#1 - 07/10/2015 05:32 PM - Dennis Box

Hi Neha,
| don't know yet how to fix the SSL errror you encountered, but here is another piece of the puzzle that is infrastructure and not explicitly jobsub
related, that must work for cilogon proxyies to authenticate.

In the voms, you have two different DNs that jobsub knows about that are used to authenticate. These can be tested with lirun:

[root@fermicloud114 ~]# /usr/sbin/lirun -s -l debug=2,mode=nogsi_ga,policy=authorize_only -d
"/DC=gov/DC=fnal/O=Fermilab/OU=People/CN=Neha Sharma/CN=UID:neha" -f "/fermilab/nova/Role=Analysis"
[llrun]: WARNING: Empty pemstring for proxy.

[llrun]: WARNING: using LCMAPS default db file.

[llrun]: LCMAPS succeeded.

[lirun]: uid=47536(neha)

[llrun]: primary gids: 1

[llrun]: pgid®=9553(undefined)

[llrun]: secondary gids: 1

[lrun): sgid®=47536(undefined)

[lrun]: poolindex=undefined

[root@fermicloud114 ~J# /usr/sbin/lirun -s -1 debug=2,mode=nogsi_ga,policy=authorize_only -d "/DC=com/DC=DigiCert-Grid/O=Open Science
Grid/OU=People/CN=Neha Sharma 225" -f "/fermilab/nova/Role=Analysis"

[llrun]: WARNING: Empty pemstring for proxy.
[lIrun]: WARNING: using LCMAPS default db file.
[lfrun]: LCMAPS succeeded.

[lfrun]: uid=47536(neha)

[lrun]: primary gids: 1

[lrun]: pgid®=9553(undefined)

[llrun]: secondary gids: 1

[lirun]: sgid®=47536(undefined)

[lfrun]: poolindex=undefined

The DN of your ClLogon proxy is "/DC=org/DC=0pensciencegrid/O=0pen Science Grid/OU=People/CN=Neha Sharma 225" . Jobsub would use this
same llirun command to authenticate with this proxy. | assume that this DN needs to be added to the VOMS, possibly things have to happen on
gums-crit.fnal.gov as well.

In summary, this command needs to work:

[root@fermicloud114 ~J# /usr/sbin/lirun -s -1 debug=2,mode=nogsi_ga,policy=authorize_only -d "/DC=o0rg/DC=0pensciencegrid/O=0Open Science
Grid/OU=People/CN=Neha Sharma 225" -f "/fermilab/nova/Role=Analysis"

[llrun]: WARNING: Empty pemstring for proxy.

[llrun]: WARNING: using LCMAPS default db file.

lcmaps®®”  LOG_ERR: 2015-07-10.22:23:46Z: lcmaps_plugin_scas_client-xacmlqueryscas(): XACML: Interaction failed: TCP/IP, SSL or SOAP
Error with endpoint: "https://gums-crit.fnal.gov:8443/gums/services/lGUMSXACMLAuthorizationServicePort"

lcmaps®'®”  LOG_ERR: 2015-07-10.22:23:46Z: SOAP 1.1 fault: XACMLcontext:StatusMessage [no subcode]

lcmaps®®”  LOG_ERR: 2015-07-10.22:23:46Z:  "Cacheloader returned null for key gov.bnl.gums.admin.MappingInput@2744f0b5."
lcmaps®®”  LOG_ERR: 2015-07-10.22:23:46Z:  Detail: <xacml-context:StatusMessage
xmlns:xacml-context="urn:oasis:names:tc:xacml:2.0:context:schema:os">CachelLoader returned null for key
gov.bnl.gums.admin.Mappinglnput@2744f0b5.</xacml-context:StatusMessage>

lcmaps®®”  LOG_ERR: 2015-07-10.22:23:46Z: Icmaps_plugin_scas_client-xacmlqueryscas(): XACML: Interaction failed: TCP/IP, SSL or SOAP
Error with endpoint: "https://gums-crit.fnal.gov:8443/gums/services/lGUMSXACMLAuthorizationServicePort"

lcmaps®®”  LOG_ERR: 2015-07-10.22:23:46Z: SOAP 1.1 fault: XACMLcontext:StatusMessage [no subcode]

lcmaps®®”  LOG_ERR: 2015-07-10.22:23:46Z:  "CachelLoader returned null for key gov.bnl.gums.admin.Mappinglnput@2744f0b5."
lcmaps®'®”  LOG_ERR: 2015-07-10.22:23:46Z:  Detail: <xacml-context:StatusMessage
xmlns:xacml-context="urn:oasis:names:tc:xacml:2.0:context:schema:os">CachelLoader returned null for key
gov.bnl.gums.admin.Mappinglnput@2744f0b5.</xacml-context:StatusMessage>

lcmaps®™®Y”  LOG_ERR: 2015-07-10.22:23:46Z: LCMAPS failed to do mapping and return account information

[llrun]: ERROR: Icmaps_return_account_without_gsi() failed.

[llrun]: ERROR: LCMAPS failed.

[root@fermicloud114 ~]#

Cheers
Dennis

#2 - 07/11/2015 12:37 AM - Parag Mhashilkar
- Assignee set to Dennis Box
- Priority changed from High to Normal

- Target version set to v1.1.5

Neha,

Did you update the CRLs on both client and server machines? Is the GUMS server configured correctly with correct mappings?
The gums error messages hint issues related to services other than jobsub. Please test that all the other components work independently before
adding jobsub to the mix.

Also, | would not treat this high priority since this issue should not hold back v1.1.4 release. Testing cilogon certs with jobsub was not part of the plan
for this release. If you want to test it for a release you should make sure that this is included in the release plan for that version with enough advance
notice to the jobsub developers.

Dennis,

| am assigning the ticket to you but | would be surprised if we need to do any changes in the jobsub to support new CAs. From protocol point of view,
all X509 certs and proxies should be identically, unless they are generated with some non standard settings.

#3 - 07/13/2015 11:37 AM - Neha Sharma
1.

Yes, the cert/crl files for the new CA are installed on both client (fermicloud042) and server ( fermicloud114)

[root@fermicloud042 nehal# rpm -gl cilogon-osg-ca-cert-1.0-1.0sg32.el6.noarch
/etc/grid-security/certificates

/etc/grid-security/certificates/70d35895.0
/etc/grid-security/certificates/70d35895.signing_policy
/etc/grid-security/certificates/cilogon-osg.crl_url
/etc/grid-security/certificates/cilogon-osg.info
/etc/grid-security/certificates/cilogon-osg.pem
/etc/grid-security/certificates/cilogon-osg.signing_policy
/etc/grid-security/certificates/d690e530.0
/etc/grid-security/certificates/d690e530.signing_policy
[root@fermicloud042 nehal#

[root@fermicloud114 ~J# rpm -gl cilogon-osg-ca-cert-1.0-1.0sg32.el6.noarch
/etc/grid-security/certificates
/etc/grid-security/certificates/70d35895.0
/etc/grid-security/certificates/70d35895.signing_policy
/etc/grid-security/certificates/cilogon-osg.crl_url
/etc/grid-security/certificates/cilogon-osg.info
/etc/grid-security/certificates/cilogon-osg.pem
/etc/grid-security/certificates/cilogon-osg.signing_policy
/etc/grid-security/certificates/d690e530.0
/etc/grid-security/certificates/d690e530.signing_policy
[root@fermicloud114 ~J#

and CRL updates are happening just fine on both client and server

[root@fermicloud042 nehal# Is hitFeteigrid-seeurity/certificatesiH-head—8
tetal-3-7M

-rw-r—+- 1 root root 1.1K Jul 13 06:45 35105088.r0
ra-r—r- 1 root root 987 Jul 13 06:45 522b8537.r0
v+ 1 root root 1003 Jul 13 06:45 6¢cad3d39.r0
rw—F—+ 1 root root 1.5K Jul 13 06:45 9ec3a561.r0
ra-r—r- 1 root root 4.6K Jul 13 06:45 b13cc6df.r0
v+ 1 root root 987 Jul 13 06:45 b7bcb7b2.r0
rw—F—+ 1 root root 1.5K Jul 13 06:45 c5e082db.r0
[root@fermicloud042 nehal#

[root@fermicloud114 ~J# Is hltfete/grid-seeurity/certificates/Hhead—8
tetal-3-8M

-p—r—- 1 root root 987 Jul 13 06:49 522b8537.r0
rw—F—+ 1 root root 1.5K Jul 13 06:49 9ec3a561.r0
ra-r—r- 1 root root 4.6K Jul 13 06:49 b13cc6df.r0
v+ 1 root root 987 Jul 13 06:49 b7bcb7b2.r0
v+ 1 root root 1.5K Jul 13 06:49 c5e082db.r0
ra-r—r- 1 root root 4.6K Jul 13 06:49 ff783690.r0
v+ 1 root root 4.6K Jul 13 06:49 24c3ccde.r0
[root@fermicloud114 ~J#

2. Jobsub server on fermicloud114 was pointing to gums-crit, which didn't have the necessary mapping
Thanks Dennis for pointing this out. | modified it to use cloudgums, so the lirun command now works

[root@fermicloud114 ~J# /usr/sbin/lirun -s -1 debug=2,mode=nogsi_ga,policy=authorize_only -d "/DC=0rg/DC=opensciencegrid/O=0Open Science
Grid/OU=People/CN=Neha Sharma 225" -f "/fermilab/nova/Role=Analysis"
[llrun]: WARNING: Empty pemstring for proxy.

[lrun]: WARNING: X509_USER_PROXY is not set.

[llrun]: WARNING: using LCMAPS default db file.

[llrun]: LCMAPS succeeded.

[lrun]: uid=50112(novaana)

[lrun]: primary gids: 1

[lirun]: pgid®=50112(novaana)

[lrun]: secondary gids: 1

[lirun]: sgid®=50112(novaana)

[lfrun]: poolindex=undefined

[root@fermicloud114 ~J#

Note: | had to create novaana user on fermicloud114. Note that cloudgums maps users differently than gums-crit ( gums-crit is using newer
configuration, which returns groupname)

Any how, what user | get mapped to here doesn't matter for current functionality testing purpose
3. | run jobsub submit again and see same failure
There is NO entry in GUMS server logs (cloudgums1/cloudgums2) for this failed request

[neha@fermicloud042 ~]$ export X509_USER_PROXY=/home/neha/x509up_u60158

[neha@fermicloud042 ~]$ voms-proxy-info -all -file $X509_USER_PROXY

subject :/DC=org/DC=opensciencegrid/O=0Open Science Grid/OU=People/CN=Neha Sharma 225/CN=proxy
issuer :/DC=org/DC=0opensciencegrid/O=0pen Science Grid/OU=People/CN=Neha Sharma 225

identity : /DC=org/DC=opensciencegrid/O=0pen Science Grid/OU=People/CN=Neha Sharma 225

type  :proxy

strength : 1024 bits
path  :/home/neha/x509up_u60158

timeleft : 11:15:49

key usage : Digital Signature, Key Encipherment, Data Encipherment === VO fermilab extension information ===
VO : fermilab

subject :/DC=org/DC=opensciencegrid/O=0Open Science Grid/OU=People/CN=Neha Sharma 225

issuer :/DC=com/DC=DigiCert-Grid/O=0pen Science Grid/OU=Services/CN=cloudvoms1.fnal.gov

attribute : /fermilab/Role=NULL/Capability=NULL

attribute : /fermilab/accelerator/Role=NULL/Capability=NULL

attribute : /fermilab/annie/Role=NULL/Capability=NULL

attribute : /fermilab/argoneut/Role=NULL/Capability=NULL

[neha@fermicloud042 ~]$ source /fnal/ups/etc/setups.sh; setup jobsub_client
[neha@fermicloud042 ~]$

[neha@fermicloud042 ~]$ jobsub_submit -G fermilab --jobsub-server=fifebatch-dev.fnal.gov
--resource-provides=usage_model=DEDICATED,OPPORTUNISTIC file:///home/neha/hello_world.sh
File "/fnal/ups/prd/jobsub_client/v1_1_3_cli/NULL/jobsub_submit", line 267, in <module>
sys.exit(main(sys.argv))

File "/fnal/ups/prd/jobsub_client/vi_1_3_cli/NULL/jobsub_submit", line 254, in main
http_code = js_client.submit()

File "/fnal/ups/prd/jobsub_client/vi_1_3_cli/NULL/jobsubClient.py", line 327, in submit
self.bestSchedd()

File "/fnal/ups/prd/jobsub_client/vi_1_3_cli/NULL/jobsubClient.py", line 546, in bestSchedd
traceback.print_stack()

HTTP response:0 PyCurl Error 56: SSL read: errno -12195

[neha@fermicloud042 ~]$

It fails before choosing whats schedd to submit job to..

#4 - 07/15/2015 12:13 PM - Dennis Box

- Status changed from New to Resolved

This was easy enough to test after | acquired a cilogon cert and Neha had gums/Icmaps.db/osg.cilogon*rpm issues straightened out. Jobsub server
can use cilogon proxies with no change to the source code. Closing the ticket.

#5 - 07/16/2015 10:00 AM - Neha Sharma

Initial error | observed during job submission was due to ClLogon cert files installed only on fermicloud114 (and not on fermicloud396). So, even
though client request landed on 114, condor_status command that checks which schedd is less loaded failed.

#6 - 08/11/2015 10:08 AM - Dennis Box

- Status changed from Resolved to Closed
